import processing.serial.*;

Serial serial;
int ball_x, ball_y, ball_dx, ball_dy, ball_size;
int xmin, xmax, ymin, ymax;
int x, y, z, s, high_byte, low_byte;

void setup()
{
  size(240, 240);
  frameRate(30);
  
  serial = new Serial(this, "COM1", 9600);
  
  ball_size = 80;
  
  xmin = ball_size / 2;
  ymin = ball_size / 2;
  xmax = width - ball_size / 2;
  ymax = height - ball_size / 2;
  
  ball_x = width / 2;
  ball_y = height / 2;
  ball_dx = 0;
  ball_dy = 0;
  
  s = 1;
}

void draw()
{
  background(0, 0, 255);
  
  if (serial.available() >= 6)
  {
    high_byte = serial.read();
    low_byte = serial.read();
    x = (high_byte << 8) + low_byte;
    
    high_byte = serial.read();
    low_byte = serial.read();
    y = (high_byte << 8) + low_byte;
    
    high_byte = serial.read();
    low_byte = serial.read();
    z = (high_byte << 8) + low_byte;
    
    ball_dx = int((512 - x) * 0.1);
    ball_dy = int((y - 512) * 0.1);
    
    serial.write(s);
  }
  
  ball_x += ball_dx;
  if (ball_x < xmin)
  {
    ball_dx = 0;
    ball_x = xmin;
  }
  if (ball_x > xmax)
  {
    ball_dx = 0;
    ball_x = xmax;
  }
  
  ball_y += ball_dy;
  if (ball_y < ymin)
  {
    ball_dy = 0;
    ball_y = ymin;
  }
  if (ball_y > ymax)
  {
    ball_dy = 0;
    ball_y = ymax;
  }
  
  noStroke();
  fill(255, 255, 255);
  ellipse(ball_x, ball_y, ball_size, ball_size);
}

void mousePressed()
{
  serial.write(s);
}
